Subject: [PATCH v3] ARM64: kernel: implement ACPI parking protocol

From: [email-masked] (Lorenzo Pieralisi)
Date: Wed, 3 Feb 2016 11:21:12 +0000

On Tue, Feb 02, 2016 at 06:26:58PM +0000, Catalin Marinas wrote:
> On Tue, Jan 26, 2016 at 11:10:38AM +0000, Lorenzo Pieralisi wrote:
> > The SBBR and ACPI specifications allow ACPI based systems that do not
> > implement PSCI (eg systems with no EL3) to boot through the ACPI parking
> > protocol specification[1].
> > 
> > This patch implements the ACPI parking protocol CPU operations, and adds
> > code that eases parsing the parking protocol data structures to the
> > ARM64 SMP initializion carried out at the same time as cpus enumeration.
> > 
> > To wake-up the CPUs from the parked state, this patch implements a
> > wakeup IPI for ARM64 (ie arch_send_wakeup_ipi_mask()) that mirrors the
> > ARM one, so that a specific IPI is sent for wake-up purpose in order
> > to distinguish it from other IPI sources.
> > 
> > Given the current ACPI MADT parsing API, the patch implements a glue
> > layer that helps passing MADT GICC data structure from SMP initialization
> > code to the parking protocol implementation somewhat overriding the CPU
> > operations interfaces. This to avoid creating a completely trasparent
> > DT/ACPI CPU operations layer that would require creating opaque
> > structure handling for CPUs data (DT represents CPU through DT nodes, ACPI
> > through static MADT table entries), which seems overkill given that ACPI
> > on ARM64 mandates only two booting protocols (PSCI and parking protocol),
> > so there is no need for further protocol additions.
> > 
> > Based on the original work by Mark Salter <[email-masked]>
> > 
> > [1] https://acpica.org/sites/acpica/files/MP%20Startup%20for%20ARM%20platforms.docx
> > 
> > Signed-off-by: Lorenzo Pieralisi <[email-masked]>
> > Cc: Will Deacon <[email-masked]>
> > Cc: Hanjun Guo <[email-masked]>
> > Cc: Loc Ho <[email-masked]>
> > Cc: Sudeep Holla <[email-masked]>
> > Cc: Catalin Marinas <[email-masked]>
> > Cc: Mark Rutland <[email-masked]>
> > Cc: Mark Salter <[email-masked]>
> > Cc: Al Stone <[email-masked]>
> 
> Applied, with a minor addition just to warn people from not using it in
> other configurations (#ifdef still needed otherwise the
> acpi_parking_protocol_valid symbol is not available; but I prefer uglier
> code than people starting to use this IPI in their firmware):

It makes sense, we could include asm/acpi.h in smp.c (which is not
included by linux/acpi.h if !CONFIG_ACPI) to pull in the symbol and
remove the ifdef if you think it is cleaner.

Thanks !
Lorenzo

> 
> --- a/arch/arm64/kernel/smp.c
> +++ b/arch/arm64/kernel/smp.c
> @@ -767,6 +767,12 @@ void handle_IPI(int ipinr, struct pt_regs *regs)
>                 break;
>  #endif
> +
> +#ifdef CONFIG_ARM64_ACPI_PARKING_PROTOCOL
>         case IPI_WAKEUP:
> +               WARN_ONCE(!acpi_parking_protocol_valid(cpu),
> +                         "CPU%u: Wake-up IPI outside the ACPI parking protocol\n",
> +                         cpu);
>                 break;
> +#endif
>  
>         default:
> 
> Thanks.
> 
> -- 
> Catalin
>